#ifndef BUTTON_H
#define BUTTON_H
#include "mode.h"

uchar btn_up_ts=0,btn_mode_ts=0;

uchar Btn_Up_Pressed()
{
    switch(mode)
    {
    case Mode_Clock_Alert:
        mode = Mode_Normal;
            break;
    case Mode_Normal:
        return 0;
    case Mode_Change_Minute:
        if(minute>=59)
            minute = 0;
        else
            ++minute;
        break;
    case Mode_Change_Hour:
        if(hour>=23)
            hour = 0;
        else
            ++hour;
        break;
    case Mode_Clock_Change_Minute:
        if(clock_minute>=59)
            clock_minute = 0;
        else
            ++clock_minute;
        break;
    case Mode_Clock_Change_Hour:
        if(clock_hour>=23)
            clock_hour = 0;
        else
            ++clock_hour;
        break;
    case Mode_Clock:
        clock_enable = !clock_enable;
        break;
    }
    second = 0;
    return 1;
}
uchar Btn_Mode_Click()
{
    switch(mode)
    {
        case Mode_Clock_Alert:
            mode = Mode_Normal;
            break;
        case Mode_Normal:
            mode = Mode_Change_Minute;
            break;
        case Mode_Change_Minute:
            mode = Mode_Change_Hour;
            break;
        case Mode_Change_Hour:
            mode = Mode_Clock;
            break;
        case Mode_Clock:
            mode = Mode_Clock_Change_Minute;
            break;
        case Mode_Clock_Change_Minute:
            mode = Mode_Clock_Change_Hour;
            break;
        case Mode_Clock_Change_Hour:
            mode = Mode_Normal;
            break;
    }
    return 1;
}

uchar Btn_Mode_LongClick()
{
    return Btn_Mode_Click();
}

uchar need_update;

uchar Button_OnTimeOut(uchar btn_up,uchar btn_mode)
{
    need_update = 0;
    if(btn_mode)
    {
        if(btn_mode_ts>10)
        {
            need_update += Btn_Mode_LongClick();
            btn_mode_ts = 0;
        }else if(btn_mode_ts)
        {
            need_update += Btn_Mode_Click();
            btn_mode_ts = 0;
        }
    }else
        btn_mode_ts += 1;
    btn_up_ts = btn_up_ts>>1;
    if(btn_up)
    {
        btn_up_ts = 0;
    }else
    {
        if(!btn_up_ts)
        {
            need_update += Btn_Up_Pressed();
            btn_up_ts = 0x01<<3;
        }
    }
    return need_update;
}

#endif //BUTTON_H