typedef unsigned char uchar;
typedef unsigned int uint; 

#include "STC8H.h"
#include "button.h"

#ifdef TESTCC
#define SEG_LED P2
#define SEG_1 P14
#define SEG_2 P15
#define SEG_3 P16
#define SEG_4 P17

#define BTN_UP P35
#define BTN_DOWN P34
#define BTN_MODE P33

void init_io()
{
	//0,0 双向口模式
    //1,0 推挽输出模式
    //0,1 高阻输入模式
    //1,1 开漏模式
    
    P1M0 = 0xf0;
    P1M1 = 0x00;
    P1 = 0x00;


    P2M0 = 0x00;
    P2M1 = 0x00;
    P2 = 0xff;

    P3M0 = 0x00;
    P3M1 = 0x00;
    P3 = 0xff;
}
#endif

#ifndef TESTCC
#define SEG_LED P3
#define SEG_1 P14
#define SEG_2 P15
#define SEG_3 P16
#define SEG_4 P17

#define BTN_UP P10
#define BTN_MODE P11

void init_io()
{
	//0,0 双向口模式
    //1,0 推挽输出模式
    //0,1 高阻输入模式
    //1,1 开漏模式
    
    P1M0 = 0xf0;
    P1M1 = 0x00;
    P1 = 0x0f;

    P3M0 = 0x00;
    P3M1 = 0x00;
    P3 = 0xff;
}
#endif



void init();
void main()
{
    init();
    while(1);
}

uchar t3_iter=0,t4_iter=0;
void init_timer()
{
    EA = 1;
    T4T3M &= 0xDD;			//定时器3,4时钟12T模式
    //2毫秒@6.000MHz
	T4L = 0x0C;				//设置定时初始值
	T4H = 0xFE;				//设置定时初始值
    //100毫秒@6.000MHz
	T3L = 0xB0;				//设置定时初始值
	T3H = 0x3C;				//设置定时初始值
    IE2 |= 0x60;			//使能定时器3,4中断
    T4T3M |= 0x88;			//定时器3,4开始计时
}

void init()
{
    init_io();
    init_timer();
}



//100毫秒@6.000MHz
void Timer3_Isr(void) interrupt 19
{
    uchar need_update;
    need_update = Button_OnTimeOut(BTN_UP,BTN_MODE);
    ++t3_iter;
    if(t3_iter == 5)
    {
        is_show_dot = !is_show_dot;
        SetSeg4Bit();
    }
    else if(t3_iter == 10)
    {
        if(mode != Mode_Change_Minute && mode != Mode_Change_Hour )
        {
            if(AddSec() && clock_enable)
            {
                //如果分钟变动:
                if(mode == Mode_Normal)
                {
                    if(minute == clock_minute && hour == clock_hour)
                        mode = Mode_Clock_Alert;
                }else if(mode == Mode_Clock_Alert)
                {
                    if(minute != clock_minute || hour != clock_hour)
                        mode = Mode_Normal;
                }
            }
        }
        is_show_dot = !is_show_dot;
        SetSeg4Bit();
        t3_iter = 0;
    }
    else if(need_update)
        SetSeg4Bit();
}

//2毫秒@6.000MHz
void Timer4_Isr(void) interrupt 20
{
    switch(t4_iter)
    {
    case 0:     //seg1
        SEG_4 = 0;
        t4_iter = 1;
        SEG_LED = seg_4bit_data[0];
        SEG_1 = 1;
        break;
    case 1:     //seg2
        SEG_1 = 0;
        t4_iter = 2;
        SEG_LED = seg_4bit_data[1];
        SEG_2 = 1;
        break;
    case 2:     //seg3
        SEG_2 = 0;
        t4_iter = 3;
        SEG_LED = seg_4bit_data[2];
        SEG_3 = 1;
        break;
    case 3:     //seg4
        SEG_3 = 0;
        t4_iter = 0;
        SEG_LED = seg_4bit_data[3];
        SEG_4 = 1;
        break;
    }
}

