#ifndef MODE_H
#define MODE_H
#include "clock.h"
#include "seg.h"

#define Mode_Normal 1
#define Mode_Change_Minute 2
#define Mode_Change_Hour 3
#define Mode_Clock 4
#define Mode_Clock_Change_Minute 5
#define Mode_Clock_Change_Hour 6
#define Mode_Clock_Alert 7

#define Mode_Show_1 hour
#define Mode_Show_2 minute

uchar is_show_dot = 1;
uchar mode = Mode_Normal;

void SetSeg4Bit()
{
    switch(mode)
    {
    case Mode_Normal:
        SetSeg4BitData_1(Mode_Show_1,is_show_dot);
        SetSeg4BitData_2(Mode_Show_2);
        break;
    case Mode_Change_Minute:
        SetSeg4BitData_1(Mode_Show_1,1);
        if(is_show_dot)
            SetSeg4BitData_2(Mode_Show_2);
        else
            SetSeg4BitData_2(SEG_NULL);
        break;
    case Mode_Change_Hour:
        if(is_show_dot)
            SetSeg4BitData_1(Mode_Show_1,1);
        else
            SetSeg4BitData_1(SEG_NULL,1);
        SetSeg4BitData_2(Mode_Show_2);
        break;
    case Mode_Clock:
        SetSeg4BitData_1(clock_hour,clock_enable);
        SetSeg4BitData_2(clock_minute);
        break;
    case Mode_Clock_Change_Minute:
        SetSeg4BitData_1(clock_hour,0);
        if(is_show_dot)
            SetSeg4BitData_2(clock_minute);
        else
            SetSeg4BitData_2(SEG_NULL);
        break;
    case Mode_Clock_Change_Hour:
        if(is_show_dot)
            SetSeg4BitData_1(clock_hour,0);
        else
            SetSeg4BitData_1(SEG_NULL,0);
        SetSeg4BitData_2(clock_minute);
        break;
    case Mode_Clock_Alert:
        if(is_show_dot)
        {
            SetSeg4BitData_1(Mode_Show_1,1);
            SetSeg4BitData_2(Mode_Show_2);
        }
        else
        {
            SetSeg4BitData_1(SEG_NULL,0);
            SetSeg4BitData_2(SEG_NULL);
        }
        break;
    }
}
#endif //MODE_H